* USES METHOD AND SYNTAX OF FRANKLAND AND ZUMBO (2002)

* http://imaging.mrc-cbu.cam.ac.uk/statswiki/FAQ/spssmix
*
* raw data is xout with bin frequencies in observed and bins [xl, xu] centred at xc
*
* Need starting estimates close to proposed means and sds of normal
* dsitributions forming the observed bimodal distribution
* Starting parameter estimates are OK here as we get good tight confidence
* intervals for the parameters and a ratio not equal to 1

*( dummy data eg generated using half the points with a mean of 2 and 
* the other half with a mean of 5 (both sds of (0.5^2)=0.25); This is correctly
* deduced using the model)

get file='E:\DEMO EDA DATA\NORMAL MIXTURES.SAV'.

GRAPH
  /HISTOGRAM=xout .

compute prop = observed/160.
model program mean1=0 mean2=3 sd1=2 sd2=2 ratio=0.5 c=0.
compute xa = abs(xl-xc).
compute xb = abs(xu-xc).
compute h1 = (0.398942/sd1)*exp(-(((xl-mean1)**2)/(2*sd1**2))).
compute h2 = (0.398942/sd1)*exp(-(((xc-mean1)**2)/(2*sd1**2))).
compute h3 = (0.398942/sd1)*exp(-(((xu-mean1)**2)/(2*sd1**2))).
compute h4 = (0.398942/sd2)*exp(-(((xl-mean2)**2)/(2*sd2**2))).
compute h5 = (0.398942/sd2)*exp(-(((xc-mean2)**2)/(2*sd2**2))).
compute h6 = (0.398942/sd2)*exp(-(((xu-mean2)**2)/(2*sd2**2))).
compute predbi = ratio*(0.5*(h1+h2)*xa + 0.5*(h2+h3)*xb)
 + (1-ratio)*(0.5*(h4+h5)*xa + 0.5*(h5+h6)*xb)+c.
cnlr prop /pred = predbi
 /bounds sd1 gt 0.0001;
         sd2 gt 0.0001;
         1.0 ge ratio ge 0.0
 /save = predbi residbi.


* UNIVARIATE EXAMPLE

 GRAPH
  /HISTOGRAM=unim5sd0.5 .

* now try on N(5, 0.5^2) data; gives good fit estimates: 5.1, 0.45

compute prop = obseuni/160.
model program mean=3.5 sd=1.6 c=0.
compute xa = abs(xluni-xcuni).
compute xb = abs(xuuni-xcuni).
compute h1 = (0.398942/sd)*exp(-(((xluni-mean)**2)/(2*sd**2))).
compute h2 = (0.398942/sd)*exp(-(((xcuni-mean)**2)/(2*sd**2))).
compute h3 = (0.398942/sd)*exp(-(((xuuni-mean)**2)/(2*sd**2))).
compute preduni = (0.5*(h1+h2)*xa + 0.5*(h2+h3)*xb) + c.
cnlr prop /pred = preduni
 /bounds sd gt 0.0001;
 /save = preduni residuni.
